\chapter{Conclusion}
\label{cap:conclusion}

Software engineering literature still presents little of what is performed by
FLOSS practitioners, their activities, and how often they happen. This
distancing from the practice leads academic works to lack a well-understanding
of the FLOSS phenomenon, carrying a homogeneous and biased perspective. From
our investigation results, we claim that software engineering research must
accept and analyze knowledge artifacts produced by practitioners to enrich
knowledge about FLOSS development. It enables to capture a more up-to-date
snapshot of the project development and challenges currently faced in the daily
activities. Also, grey literature brings the nuances of the real world from the
practitioners' point of view.

Alongside commercial and academic publications, GL is used to broaden the
academic understanding of how FLOSS developers interpret their daily work
environment. Despite the informality of GL, it brings advantages of its own.
Studies with negative or null results are easier to find in GL than in
peer-reviewed academic literature, enabling a more critical perspective, with a
potential reduction of bias and visualization of more balanced
evidence~\citep{Paez2017}. GL is also a leading source for identifying topics
and gaps not yet covered by academic literature. It also enables the
investigation of more up-to-date and emerging information since academic
studies incur long publication delays due to the peer-review process.

Bearing this in mind, we reviewed the grey literature and systematized the Linux
kernel community characteristics in a mind map where concepts are
grouped in three main topics: General Characteristics, Ecosystem, and Concerns.
With this mapping, we answer \textit{\textbf{RQ1. How do software engineering studies and Linux community publications describe the current Linux development community model?}} and \textit{ RQ1.1. What attributes practitioners use to characterize the Linux development community? What are the current social and organizational challenges from the community perspective?}. Consequently, the
resulted mind map provides \textbf{C1. A comprehensive characterization of the
contemporary Linux kernel development community.} and explains \textbf{C2.
Community characteristics and social-technical nuances that shapes a FLOSS
project development}. It may
also help FLOSS researchers evaluate if the Linux project fits the
characteristics desired for their investigation.

We combined several data collection methods to provide a comparison of our
findings from academic and community publications that answer
\textit{RQ1.2. Do Software Engineering studies already cover these topics?}.
With a comparative mind map and discussion from development trenches, we
elucidated the pace between the Linux kernel community and Software Engineering
studies and deliver \textbf{C4.1 A map of potentially misleading information
gaps between theory and practice in the contemporary Linux kernel development
community.}

Because GLR is still a nascent trend, just a few software engineering reviews have
already included GL materials~\citep{Bailey2007,travassos2016SLR,Soldani2018}.
Although there are recommendations for GL material inclusion in literature
reviews, there is not yet a precise methodology or guidelines prescribing
well-defined steps and restrictions for conducting Grey Literature Reviews
(GLR). Some researchers have mitigated this problem by applying systematic
review methods for examining GL. Nevertheless, conducting GLR still requires
adaptations for handling the variety in quality, size, types, and structures of
documents, besides the larger volume of available materials compared to a
traditional literature review. Moreover, the reviewer must deal with the lack
of robust search engines and textual and natural language analysis challenges.

Hence, we reported in Chapter \ref{cap:linuxdevmodel} a set of
mechanisms for data collection and analysis to systematically examine grey
materials produced by members of a FLOSS ecosystem.
This investigative design answers our \textit{\textbf{RQ2. What research techniques can be used to examine a FLOSS project through its community publications?}} and contributed with \textbf{C3. Guidelines to
examine FLOSS projects through its community publications.} We overlapped data
from GLR, SLR, and Participant-Observation to identify topics with
misunderstandings or shallow coverage on FLOSS studies that deserve more
in-depth investigations. This multi-method approach presents \textbf{C4. A
combination of research strategies that could boost research on
FLOSS ecosystems} and answers \textit{\textbf{RQ3. What are the possible gaps and opportunities for academic research in FLOSS development topics?}}

%% ------------------------------------------------------------------------- %%
\section{Future Work}

Our work shows that grey Literature is a leading source for identifying topics
and issues from the real world not yet covered by academic literature.
We believe that the use of grey documents enables a researcher to start from a
more prosperous basis by capturing parts of the practice. However, the lack of
data contrast is dangerous due to the power of incorporating more bias and
misleading information for research design and, consequently, skewed results
since personal opinions are intricate to this information source.

From our content analysis and critical discussion, FLOSS researchers may find
opportunities to conduct in-depth investigations of some Linux kernel practices
and expand state-of-art and -practice even more. 
Future works should address an explicit comparison of each of the
concepts obtained from multivocal literature review to the third perspective of
participant observation in the Linux kernel development community.

The selected grey documents, practitioners' also revealed particular concerns
about most code change
authorship in the Linux kernel project being concentrated in top contributors.
These contributors are usually subsystem maintainers and also employees of
large companies. In this scenario, continuing to examine the influence of
outside organization in the project is essential, \textit{``not to malign the
sponsorship or participation of corporations or governments in FOSS, but to
show how these may skew the dynamics of a FOSS project''}~\citep{Forrest2012}.

We observed issues in the current Linux kernel development model that are
little discussed in formal literature. First,
the current code maintenance organization and how it impacts active developers.
This subject includes issues in the maintainer's routines, such as signs of
stress, burn-out, fears, paralysis in the face of innovations, and topics
regarding the hierarchy of commit-rights, the double-standard in patch reviews
and commits, and the distinct models of maintainership per subsystem. Future
FLOSS research should address an in-depth investigation of these concepts to
identify the challenges and benefits of changing the maintainership model
(between the single, group, and multiple-committers) to support processes
scalability and mitigate bottlenecks suggested by traditional and grey
literature in the current pre-commit review process.

Second, we mapped research opportunities regarding community subsistence: the
difficulty in transferring knowledge and the steep learning curve. Both
contribute to the aging of the community and missing younger voluntary
contributors. On the one hand, these issues may be addressed by companies
developing new contributors in-house. On the other hand, abusive culture on
communication, conduct issues, and a toxic environment would affect new and
active developers. In addition, future works should consider other means of
communication and decision-making besides the mailing-lists, such as IRC
channels and conferences.

Lastly, FLOSS research should benefit from investigations of the source code's
continuous growth and the impacts on source code and processes of embracing the
non-regression rule. Also, studies should evaluate the significance of the code
change authorship centralized in top contributors, usually maintainers and
large companies' employees. All these issues are mapped in this thesis and
deserve further scrutiny by the research community.

Our claimed contributions and the wealth of information in this work reveal the
importance of using investigative methods able to embrace the continuous
transformations of the FLOSS phenomenon and the social aspects of
community-based development. The review of community publications and direct
participation in developing a project as a community member are
strategies not commonly used in the studies of Software Engineering in FLOSS.
In our work, the use of Multivocal Literature Review and Participant-Observation
brought academia closer to the everyday practice of developing the Linux
kernel, collecting richer and more up-to-date data, and identifying
undocumented social aspects and unspoken rules. Given the results obtained
here, we understand that these methods fit very well in the characteristics of
the development of FLOSS and should be strongly considered in further
research in the area.

%% FAZ TEU NOME
